/*
  Copyright (C) 2004-2007 University Corporation for Advanced Internet Development, Inc.
  Copyright (C) 2004-2007 The University Of Chicago

  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.
  You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

  Unless required by applicable law or agreed to in writing, software
  distributed under the License is distributed on an "AS IS" BASIS,
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  See the License for the specific language governing permissions and
  limitations under the License.
*/

package edu.internet2.middleware.grouper.exception;

/**
 * Exception thrown when an attribute def scope is not found within the Groups
 * Registry.
 * <p/>
 * @author  mchyzer.
 * @version $Id: AttributeDefNameSetNotFoundException.java,v 1.1 2009/06/30 05:15:15 mchyzer Exp $
 */
@SuppressWarnings("serial")
public class AttributeDefNameSetNotFoundException extends RuntimeException {
  
  /**
   * 
   */
  public AttributeDefNameSetNotFoundException() { 
    super(); 
  }
  
  /**
   * 
   * @param msg
   */
  public AttributeDefNameSetNotFoundException(String msg) { 
    super(msg); 
  }
  
  /**
   * 
   * @param msg
   * @param cause
   */
  public AttributeDefNameSetNotFoundException(String msg, Throwable cause) { 
    super(msg, cause); 
  }
  
  /**
   * 
   * @param cause
   */
  public AttributeDefNameSetNotFoundException(Throwable cause) { 
    super(cause); 
  }
}

